Get workflow runs
GET/v1/workflows/runs
This route allows you to retrieve a list of workflow runs with optional filtering by status, result, workflow, and more.
To learn more about workflows, see the documentation.
Request
Parameters (JSON)
{
"parameters": [
{
"schema": {
"type": "integer",
"exclusiveMinimum": true,
"maximum": 1000
},
"in": "query",
"name": "limit",
"required": false,
"description": "Maximum number of items to return."
},
{
"schema": {
"type": "integer",
"minimum": 0,
"maximum": 9007199254740991
},
"in": "query",
"name": "offset",
"required": false,
"description": "Number of items to skip for pagination."
},
{
"schema": {
"type": "array",
"items": {
"type": "string",
"pattern": "^wfr_[a-zA-Z0-9]{16}$"
}
},
"in": "query",
"name": "workflowRunIdentifiers",
"required": false,
"description": "Filter by specific workflow run identifiers.",
"style": "form",
"explode": true
},
{
"schema": {
"type": "array",
"items": {
"type": "string"
}
},
"in": "query",
"name": "workflowIdentifiers",
"required": false,
"description": "Filter by workflow identifiers.",
"style": "form",
"explode": true
},
{
"schema": {
"type": "array",
"items": {
"type": "string",
"pattern": "^wfv_[a-zA-Z0-9]{16}$",
"example": "wfv_aaaaaaaaaaaaaaaa"
}
},
"in": "query",
"name": "workflowVersionIdentifiers",
"required": false,
"description": "Filter by workflow version identifiers.",
"style": "form",
"explode": true
},
{
"schema": {
"type": "string"
},
"in": "query",
"name": "createdBy",
"required": false,
"description": "Filter by the user who created the workflow run."
},
{
"schema": {
"type": "array",
"items": {
"type": "string"
}
},
"in": "query",
"name": "excludeCreatedBy",
"required": false,
"style": "form",
"explode": true
},
{
"schema": {
"type": "array",
"items": {
"type": "string",
"enum": [
"COMPLETED",
"IN_PROGRESS",
"CANCELLING",
"WAITING_FOR_INPUT"
]
}
},
"in": "query",
"name": "statuses",
"required": false,
"description": "Filter by workflow run statuses.",
"style": "form",
"explode": true
},
{
"schema": {
"type": "array",
"items": {
"type": "string",
"enum": [
"CANCELLED",
"SUCCESS",
"FAILED"
]
}
},
"in": "query",
"name": "results",
"required": false,
"description": "Filter by workflow run results.",
"style": "form",
"explode": true
},
{
"schema": {
"type": "array",
"items": {
"type": "string",
"enum": [
"UI",
"API",
"EVENT",
"TEST",
"MCP"
]
}
},
"in": "query",
"name": "sources",
"required": false,
"description": "Filter by workflow run sources.",
"style": "form",
"explode": true
},
{
"schema": {
"type": "array",
"items": {
"type": "string",
"enum": [
"SUCCESS",
"FAILED",
"CANCELLED",
"CANCELLING",
"WAITING_FOR_INPUT",
"IN_PROGRESS"
]
}
},
"in": "query",
"name": "displayStatuses",
"required": false,
"description": "Filter by the status shown in the UI, matching any of the given values. `SUCCESS`, `FAILED` and `CANCELLED` match the run result, the others match the run status. Combined with `statuses` and `results` using AND, so contradictory combinations return no runs.",
"style": "form",
"explode": true
},
{
"schema": {
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
"in": "query",
"name": "createdAfter",
"required": false,
"description": "Only return runs created at or after this ISO 8601 date-time."
},
{
"schema": {
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
"in": "query",
"name": "createdBefore",
"required": false,
"description": "Only return runs created before this ISO 8601 date-time."
},
{
"schema": {
"type": "boolean"
},
"in": "query",
"name": "excludeNodeRuns",
"required": false,
"description": "When true, `nodeRuns` is returned as an empty array for every run."
}
]
}Request body schema (JSON)
{
"title": "Body"
}Responses
- 200
- 403
- 422
- 500
Default Response
Default Response
Default Response
Default Response
Responses (JSON)
{
"responses": {
"200": {
"description": "Default Response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"ok": {
"type": "boolean"
},
"workflowRuns": {
"type": "array",
"items": {
"type": "object",
"properties": {
"identifier": {
"type": "string",
"pattern": "^wfr_[a-zA-Z0-9]{16}$"
},
"workflowVersionIdentifier": {
"type": "string",
"pattern": "^wfv_[a-zA-Z0-9]{16}$"
},
"nodeRuns": {
"default": [],
"type": "array",
"items": {
"type": "object",
"properties": {
"identifier": {
"type": "string",
"pattern": "^wfnr_[a-zA-Z0-9]{16}$"
},
"output": {
"default": {},
"type": "object",
"additionalProperties": {}
},
"links": {
"default": [],
"type": "array",
"items": {
"type": "string",
"format": "uri"
}
},
"status": {
"type": "string",
"enum": [
"COMPLETED",
"IN_PROGRESS",
"CANCELLING",
"WAITING_FOR_INPUT"
]
},
"result": {
"anyOf": [
{
"type": "string",
"enum": [
"CANCELLED",
"SUCCESS",
"FAILED",
"CACHED"
]
},
{
"type": "null"
}
]
},
"statusLabel": {
"type": "object",
"properties": {
"text": {
"type": "string",
"minLength": 1,
"description": "The label text. Supports JQ expressions for dynamic content."
},
"variant": {
"description": "Semantic variant controlling the label color/style.",
"type": "string",
"enum": [
"success",
"alert"
]
}
},
"required": [
"text"
],
"additionalProperties": false
},
"externalRunId": {
"anyOf": [
{
"type": "string"
},
{
"type": "null"
}
]
},
"reauthUrl": {
"anyOf": [
{
"type": "string"
},
{
"type": "null"
}
]
},
"createdAt": {
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
"updatedAt": {
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
"completedAt": {
"anyOf": [
{
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
{
"type": "null"
}
]
},
"node": {
"type": "object",
"properties": {
"identifier": {
"type": "string"
}
},
"required": [
"identifier"
],
"additionalProperties": false
}
},
"required": [
"identifier",
"links",
"status",
"createdAt",
"updatedAt",
"node"
],
"additionalProperties": false,
"title": "nodeRun"
}
},
"status": {
"type": "string",
"enum": [
"COMPLETED",
"IN_PROGRESS",
"CANCELLING",
"WAITING_FOR_INPUT"
]
},
"result": {
"anyOf": [
{
"type": "string",
"enum": [
"CANCELLED",
"SUCCESS",
"FAILED"
]
},
{
"type": "null"
}
]
},
"statusLabel": {
"type": "object",
"properties": {
"text": {
"type": "string",
"minLength": 1,
"description": "The label text. Supports JQ expressions for dynamic content."
},
"variant": {
"description": "Semantic variant controlling the label color/style.",
"type": "string",
"enum": [
"success",
"alert"
]
}
},
"required": [
"text"
],
"additionalProperties": false
},
"source": {
"default": "API",
"type": "string",
"enum": [
"UI",
"API",
"EVENT",
"TEST",
"MCP"
]
},
"completedAt": {
"anyOf": [
{
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
{
"type": "null"
}
]
},
"createdAt": {
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
"updatedAt": {
"type": "string",
"format": "date-time",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
},
"workflowVersion": {
"anyOf": [
{
"type": "object",
"properties": {
"versionIdentifier": {
"anyOf": [
{
"type": "string",
"pattern": "^wfv_[a-zA-Z0-9]{16}$"
},
{
"type": "null"
}
]
},
"workflow": {
"type": "object",
"properties": {
"identifier": {
"anyOf": [
{
"type": "string",
"maxLength": 60,
"pattern": "^[\\p{L}0-9@_:-]+$"
},
{
"type": "string",
"maxLength": 60,
"pattern": "^system\\.[\\p{L}0-9@_:-]+$"
}
]
}
},
"required": [
"identifier"
],
"additionalProperties": false
}
},
"required": [
"workflow"
],
"additionalProperties": false
},
{
"type": "null"
}
]
},
"createdBy": {
"type": "string"
},
"impersonatedUserId": {
"anyOf": [
{
"type": "string"
},
{
"type": "null"
}
]
}
},
"required": [
"identifier",
"workflowVersionIdentifier",
"nodeRuns",
"status",
"source",
"createdAt",
"updatedAt",
"createdBy"
],
"additionalProperties": false,
"title": "workflowRun"
}
}
},
"required": [
"ok",
"workflowRuns"
],
"additionalProperties": false
}
}
}
},
"403": {
"description": "Default Response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"ok": {
"type": "boolean"
},
"error": {
"type": "string"
},
"message": {
"type": "string"
}
},
"required": [
"ok",
"error"
],
"additionalProperties": false,
"title": "serverError"
}
}
}
},
"422": {
"description": "Default Response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"ok": {
"type": "boolean"
},
"error": {
"type": "string"
},
"message": {
"type": "string"
}
},
"required": [
"ok",
"error"
],
"additionalProperties": false,
"title": "serverError"
}
}
}
},
"500": {
"description": "Default Response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"ok": {
"type": "boolean"
},
"error": {
"type": "string"
},
"message": {
"type": "string"
}
},
"required": [
"ok",
"error"
],
"additionalProperties": false,
"title": "serverError"
}
}
}
}
}
}